<?php
/* Autor...: William L. Taype Perez */
/* Esquema.: SEG_SubSistema.xml */
/* Generado: 2020-08-18 04:21:30 */

/* Mantenimiento de los registros de la tabla SEG_SubSistema */
abstract class BaseSEG_SubSistemaDP extends SEG_SubSistemaBV
{
    /* Constructor ( Establece los valores desde un objeto SEG_SubSistemaBN ) */
    public function __construct( SEG_SubSistemaBN $o_SEG_SubSistemaBN = null )
    {
        parent::__construct();
        if ( !is_null( $o_SEG_SubSistemaBN ) )
        {
            $this->setByBN( $o_SEG_SubSistemaBN );
        }
    }

    public $b_Debug = false;

    public function getDebug()
    {
        if( SF_DEBUG )
        {
            $this->b_Debug = true;
        }
        return $this->b_Debug;
    }

    public function setDebug( $v )
    {
        $this->b_Debug = $v;
    }

    /* Establece los valores desde un objeto SEG_SubSistemaBN */
    public function setByBN( SEG_SubSistemaBN $o_SEG_SubSistemaBN )
    {
        if ( !is_null( $o_SEG_SubSistemaBN->getIdSubSistema() ) )
        {
            $this->setIdSubSistema( $o_SEG_SubSistemaBN->getIdSubSistema() );
        }
        if ( !is_null( $o_SEG_SubSistemaBN->getSubSistemaDescripcion() ) )
        {
            $this->setSubSistemaDescripcion( $o_SEG_SubSistemaBN->getSubSistemaDescripcion() );
        }
        if ( !is_null( $o_SEG_SubSistemaBN->getSubSistemaDir() ) )
        {
            $this->setSubSistemaDir( $o_SEG_SubSistemaBN->getSubSistemaDir() );
        }
        if ( !is_null( $o_SEG_SubSistemaBN->getTareaPrefijo() ) )
        {
            $this->setTareaPrefijo( $o_SEG_SubSistemaBN->getTareaPrefijo() );
        }
        if ( !is_null( $o_SEG_SubSistemaBN->getFechaCreacion() ) )
        {
            $this->setFechaCreacion( $o_SEG_SubSistemaBN->getFechaCreacion() );
        }
        if ( !is_null( $o_SEG_SubSistemaBN->getUsuarioCreacion() ) )
        {
            $this->setUsuarioCreacion( $o_SEG_SubSistemaBN->getUsuarioCreacion() );
        }
        if ( !is_null( $o_SEG_SubSistemaBN->getFechaModificacion() ) )
        {
            $this->setFechaModificacion( $o_SEG_SubSistemaBN->getFechaModificacion() );
        }
        if ( !is_null( $o_SEG_SubSistemaBN->getUsuarioModificacion() ) )
        {
            $this->setUsuarioModificacion( $o_SEG_SubSistemaBN->getUsuarioModificacion() );
        }
    }

    /* Graba un nuevo registro */
    public function save()
    {
        $this->validateRecord();
        $o_SEG_SubSistemaFN = new SEG_SubSistemaFN();
        $o_SEG_SubSistemaBN = $o_SEG_SubSistemaFN->selectByPk( $this->getIdSubSistema() );
        if ( is_null( $o_SEG_SubSistemaBN ) )
        {
            $s_SQLQuery1 = "INSERT INTO SEG_SubSistema ( ";
            $s_SQLQuery2 = "VALUES ( ";
            $s_Separator = "";
            if ( !is_null( $this->getIdSubSistema() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdSubSistema";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdSubSistema()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getSubSistemaDescripcion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."SubSistemaDescripcion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getSubSistemaDescripcion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getSubSistemaDir() ) )
            {
                $s_SQLQuery1 .= $s_Separator."SubSistemaDir";
                $s_SQLQuery2 .= $s_Separator."'".$this->getSubSistemaDir()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTareaPrefijo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."TareaPrefijo";
                $s_SQLQuery2 .= $s_Separator."'".$this->getTareaPrefijo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery = $s_SQLQuery1." ) ".$s_SQLQuery2." );";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        }
        else
        {
            throw new Exception( "El id ya esta registrado." );
        }
        return true;
    }

    /* Actualiza los datos del registro */
    public function update()
    {
        $this->validateRecord();
        if ( true )
        {
            $s_SQLQuery = "UPDATE SEG_SubSistema SET ";
            $s_Separator = "";
            if ( !is_null( $this->getSubSistemaDescripcion() ) )
            {
                $s_SQLQuery .= $s_Separator."SubSistemaDescripcion = '".$this->getSubSistemaDescripcion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getSubSistemaDir() ) )
            {
                $s_SQLQuery .= $s_Separator."SubSistemaDir = '".$this->getSubSistemaDir()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTareaPrefijo() ) )
            {
                $s_SQLQuery .= $s_Separator."TareaPrefijo = '".$this->getTareaPrefijo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaCreacion = '".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioCreacion = '".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaModificacion = '".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioModificacion = '".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery .= " WHERE  IdSubSistema = '".$this->getIdSubSistema()."';";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }

        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Elimina el registro */
    public function delete()
    {
        $s_SQLQuery = "DELETE FROM SEG_SubSistema WHERE  IdSubSistema = '".$this->getIdSubSistema()."';";
        $o_Resource = Conexion::getConexion();
        $o_Statement = $o_Resource->createStatement();
        $o_Statement->executeQuery( $s_SQLQuery );
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        return true;
    }

}
?>